package com.iluwatar.monitor;

/**
 * Assertions that may be checked from time to time.
 */
public abstract class Assertion {

  private static final String DEFAULTMESSAGE = "Assertion Failure";

  protected String message = DEFAULTMESSAGE;

  /** This method says whether the assertion is true. */
  public abstract boolean isTrue();

  /** Throw an AssertionError if the assertion is not true. */
  public void check() {
    check(isTrue(), message);
  }

  /** Throw an AssertionError if the parameter is not true. */
  public static void check(boolean b) {
    check(b, DEFAULTMESSAGE);
  }

  /** Throw an AssertionError if the boolean parameter is not true. */
  public static void check(boolean b, String message) {
    if (!b) {
      throw new AssertionError(message);
    }
  }
}